package com.liang.dao;

import com.liang.entity.BaseArea;
import com.liang.entity.BaseCompany;
import com.liang.entity.BaseTitle;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

/**
 * (BaseArea)表数据库访问层
 *
 * @author makejava
 * @since 2023-02-15 23:13:10
 */
public interface BaseAreaDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    BaseArea queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param baseArea 查询条件
     * @param pageable 分页对象
     * @return 对象列表
     */
    List<BaseArea> queryAllByLimit(BaseArea baseArea, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param baseArea 查询条件
     * @return 总行数
     */
    long count(BaseArea baseArea);

    /**
     * 新增数据
     *
     * @param baseArea 实例对象
     * @return 影响行数
     */
    int insert(BaseArea baseArea);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<BaseArea> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<BaseArea> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<BaseArea> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<BaseArea> entities);

    /**
     * 修改数据
     *
     * @param baseArea 实例对象
     * @return 影响行数
     */
    int update(BaseArea baseArea);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    /**
     * 获取所有数据
     *
     * @return
     */
    List<BaseArea> queryAll();

    /**
     * 获取国家列表
     *
     * @return
     */
    List<BaseArea> getCountryList(Map map);

    /**
     * 获取国家
     *
     * @return
     */
    List<Map<String, String>> getCountry();
}

